/*
 * ̃vO̒쌠AgpAۏ؂̔۔FɂẮA
 * "LICENCE.txt"QƂ̂
 */

/* 
 * hddd|SWWvvOiT[rXNGXgp|g`ωj 
 * Ver. 1.0 
 */

/* ̃t@C(measurement.cpp)́Av̏Ɋւ鏔֐܂ށB
 */

#include	<windows.h>
#include	<stdio.h>
#include	<process.h>
#include	<math.h>

#include	"resource.h"
#include	"measurement.h"
#include	"state.h"
#include	"option.h"

/* Ot@CŒ`ꂽ֐̐錾ivg^Cv錾j
 * O[oϐ̐錾
 */
	/* "winmain.cpp"QƂ̂ */
	void DisplayInformation (char *buf);
	extern HWND	hwnd_dlg;

	/* "display.cpp"QƂ̂ */
	void RefreshDisplay();
	void DrawPixel (double x_pos, double y_pos);
	void UpdateDisplay ();

	/* "save.cpp"QƂ̂ */
	void SaveInTheFile (DWORD option, char *affix, char *sbuf);
	void SaveMemo();

	/* "timer.cpp"QƂ̂ */
	void TimeMillisecond (double *pTime);
	void TimeSecond (double *pTime);

	/* "gpib.cpp"QƂ̂ */
	void InitGPIB(int address);
	void SendMsgToDevice (char *message);
	void GetMsgFromDevice (char *message, DWORD buf_size);
	int	 GetWFM (short *wfm, DWORD data_num);
	void EndGPIB();

/* ̃t@CŒ`֐̐錾ivg^Cv錾j */
void	InitOSC();
unsigned _stdcall Measurement (void *param);

/* ̃t@CŒ`O[oϐ̐錾 */
DWORD	measurement_state;
HANDLE	hComEvent;		/* handle to event object for thread communication */
HANDLE	hTriggerEvent;

/************* ̃t@CŌĂяo֐ *****************************/
void InitMeasurement()
{
	InitOSC();
	
	hComEvent = CreateEvent (NULL, FALSE, FALSE, NULL);
	if (!hComEvent) {
		DisplayInformation ("error: hComEvent = CreateEvent()");
	}

	hTriggerEvent = CreateEvent (NULL, FALSE, FALSE, NULL);
	if (!hTriggerEvent) {
		DisplayInformation ("error: hComEvent = CreateEvent()");
	}

	return;
}

void InitOSC()
{
	char	cbuf[STRING_LENGTH];

	InitGPIB (DEFAULT_ADDRESS);

	SendMsgToDevice ("*RST");

	SendMsgToDevice ("SELECT CH1: ON");

	SendMsgToDevice ("ACQUIRE:MODE AVERAGE");
	sprintf (cbuf, "ACQUIRE:NUMAVG %d", DEFAULT_AVERAGE_NUMBER);
	SendMsgToDevice (cbuf);

	SendMsgToDevice ("DATA:SOURCE CH1");
	SendMsgToDevice ("DATA:ENCDG ASCII");	/* uASCIIf[^]vw */
	SendMsgToDevice ("DATA:WIDTH 2");		/* ef[^|CgɂQoCg蓖Ă */
	sprintf (cbuf, "DATA:START %d", DEFAULT_DATA_START); 
	SendMsgToDevice (cbuf);
	sprintf (cbuf, "DATA:STOP %d", DEFAULT_DATA_STOP); 
	SendMsgToDevice (cbuf);

	SendMsgToDevice ("ACQUIRE:STOPAFTER SEQUENCE");
	SendMsgToDevice ("TRIGGER:MAIN:MODE NORMAL");

	sprintf (cbuf, "HORIZONTAL:MAIN:SCALE %s", DEFAULT_X_SCALE); 
	SendMsgToDevice (cbuf);

	sprintf (cbuf, "CH1:SCALE %s", DEFAULT_Y_SCALE); 
	SendMsgToDevice (cbuf);
	
	sprintf (cbuf, "CH1:POSITION %s", DEFAULT_POSITION); 
	SendMsgToDevice (cbuf);

	sprintf (cbuf, "TRIGGER:MAIN:LEVEL %s", DEFAULT_TRIGGER_LEVEL); 
	SendMsgToDevice (cbuf);
	
	SendMsgToDevice ("ACQUIRE:STATE ON");
	SendMsgToDevice ("TRIGGER FORCE");
	SendMsgToDevice ("*WAV");

	SendMsgToDevice ("DESE 1");
	SendMsgToDevice ("*ESE 1");
	SendMsgToDevice ("*SRE 32");

	SendMsgToDevice ("*CLS");

	return;
}

void RegisterState (DWORD state)
{
	measurement_state = state;
	return;
}

void StartMeasurement()
{
	HANDLE	threadHandle;	
	DWORD	threadID;

	threadHandle = (HANDLE)_beginthreadex(0, 0, Measurement, 
					NULL, 0, (unsigned *) &threadID);
	CloseHandle (threadHandle);
	return;
}

void TriggerMeasurement()
{
	SetEvent(hTriggerEvent);
	return;
}

void StopMeasurement()
{
	SetEvent(hComEvent);
	return;
}

void EndMeasurement()
{ 
	EndGPIB();

	CloseHandle (hComEvent);
	CloseHandle (hTriggerEvent);
	return;
}

/************* ̃t@Cł̂ݎgp֐ ***********************/
unsigned _stdcall Measurement (void *param)
{
	DWORD	count;
	double	time_0, time_1, elapsed_time;

	double	xincr, pt_off, ymult, yoff;

	int criterion;

	double	time_wfm;
	short	wfm[DEFAULT_DATA_STOP - DEFAULT_DATA_START + 1];
	double	voltage[DEFAULT_DATA_STOP - DEFAULT_DATA_START + 1];

	DWORD	i;
	char	cbuf[STRING_LENGTH]	= "";
	char	sbuf[STRING_LENGTH]	= "";

	SendMsgToDevice ("WFMPRE:CH1:XINCR?");
	GetMsgFromDevice (cbuf, sizeof(cbuf));
	sscanf (cbuf, "%lf", &xincr);
	
	SendMsgToDevice ("WFMPRE:CH1:PT_OFF?");
	GetMsgFromDevice (cbuf, sizeof(cbuf));
	sscanf (cbuf, "%lf", &pt_off);
	
	SendMsgToDevice ("WFMPRE:CH1:YMULT?");
	GetMsgFromDevice (cbuf, sizeof(cbuf));
	sscanf (cbuf, "%lf", &ymult);

	SendMsgToDevice ("WFMPRE:CH1:YOFF?");
	GetMsgFromDevice (cbuf, sizeof(cbuf));
	sscanf (cbuf, "%lf", &yoff);

	SendMsgToDevice ("*WAV");

	sprintf (cbuf, "xincr = %e, pt_off = %e, ymult = %e, yoff = %e", xincr, pt_off, ymult, yoff);
	DisplayInformation (cbuf);

	count = 1;

	while (1) {
		if (WaitForSingleObject(hComEvent, 0) == WAIT_OBJECT_0)	{
			DisplayInformation ("Stop measurement!");
			break;
		}

		if (count==1) {
			elapsed_time = 0;
			TimeSecond (&time_0);	/* ̎擾 */
		}

		criterion = GetWFM (wfm, DEFAULT_DATA_STOP - DEFAULT_DATA_START + 1);
		TimeSecond (&time_1);	/* ̎擾 */ 

		/* 񐔂̕\ */
		sprintf (cbuf, "%d", count);
		SetDlgItemText (hwnd_dlg, IDC_COUNT, cbuf);

		/* oߎԂ̌vZƕ\ */
		elapsed_time = elapsed_time + (time_1 - time_0);
		time_0 = time_1;
		sprintf (cbuf, "%5.2f", elapsed_time);
		SetDlgItemText (hwnd_dlg, IDC_ELAPSED_TIME, cbuf);

		/* f[^̕\ */
		if(criterion == TRUE){
			RefreshDisplay();
			for (i = 0;i < DEFAULT_DATA_STOP - DEFAULT_DATA_START + 1;i++) {
				voltage[i] = ((double)wfm[i] - yoff) * ymult;
				DrawPixel ((double)i/(double)(DEFAULT_DATA_STOP-DEFAULT_DATA_START+1), voltage[i]/V_MAX);
			}
			UpdateDisplay ();
	
			/* f[^̕ۑ */
			if (measurement_state == SAVE) {/* vȂf[^ۑ */
				sprintf (cbuf, "_%d", count);
				sprintf (sbuf, "Number\tTime(s)\tVoltage(V)\tElappsed_Time(s)\r\n");
				SaveInTheFile (NEW, cbuf, sbuf);

				time_wfm = (-pt_off - 1) * xincr;
				sprintf (sbuf, "0\t%e\t%f\t%f\r\n", time_wfm, voltage[0], elapsed_time);
				SaveInTheFile (EXISTING, cbuf, sbuf);		
				for (i = 1;i < DEFAULT_DATA_STOP - DEFAULT_DATA_START + 1;i++) {
					time_wfm = (i - pt_off -1) * xincr;
					sprintf (sbuf, "%d\t%e\t%f\r\n", i, time_wfm, voltage[i]);
					SaveInTheFile (EXISTING, cbuf, sbuf);
				}
			}
		}/* if(criterion == TRUE) */

		count++;		
	}

	SaveMemo();

	return 0;
}